2004-07-24

	* Toothpaste path splines were not being freed.

	* Laser level 0 reload rate decreased, level 1 angles away
	slightly to cover a wider area.  Toothpaste level 2 has 2 shots
	out the back when a target is locked (cause it looks good :).

	* Sound was still being played sometimes when muted.

	* Minor tweaks.  Debri slowed down.  Explosions sped up.
	Fireballs slowed down to be a nuisance.

	* Turrets use more the general Weapon classes.

	* Stone turret now fires fireballs in waves (of 4).  Health
	decreased slightly to compensate.  Increased Anvil health.

	* Homing missiles seriously crippled (was WAY too powerful).

	* Highscores were not carried across levels as intended.

	* Health powerups picked up while player was invicible was ignored.

	* Initial release (version 0.1).

2004-07-23

	* Force feedback (for windows).

	* Toothpaste no longer goes stupid when the enemy moves too far
	away from its position when it was first locked onto (by
	calculating a new, sorter spline).

	* Players picking up health also made invincible for a tick so you
	don't get things like this: 2hp -> 5hp -> 1hp -> confusion.  Also
	lengthened invulnerable tics.  Also increase health powerup to
	give 4 hp.

	* Tweaks.  Made laser more usable.  EvilVulcan slowed down.
	Bigger circles when player gets hurt.  Nuke size increased.

	* Incoming robots and satellites don't get hurt.

2004-07-22

	* More proper magic and version control for maps.  New map format
	(add a linefeed after version number).

	* Fix bug causing customizing player2's controls to go to player1.

	* Fireball death animation was not being drawn properly.

	* Less ugly credits.

	* Statusbar bitmaps when using triple buffering was not being
	initialized properly.

	* Joystick stuff.  Guess restart button.  Disabling (in menu).  No
	longer check player 2 restart button when in 1 player mode.  No
	longer check joy 2 if you only had 1 joy (due to defaults).

	* Scorefile compatability with Windows.

	* Triple buffer was being weird.  Don't really get it.

2004-07-21

	* New graphics:
	  - Additional desert tiles (tents, roads)

	* Dying players will no longer receive powerups.

	* Remove "Tank" from Newt/Gecko/Lizard-Tanks.  (Will break maps!)

	* Gecko debri and firing animation.

	* Laser levels 1 and 2 firing rate upped, and projectile widened.

2004-07-20

	* Renamed Sweeper to LittleDeath.  (Will break maps!)

	* Highscores.  Also give score for powerups.

	* Game Over, Paused, Level Complete and Highscore, pictures.

2004-07-19

	* New graphics:
	  - Mainmenu backdrop
	  - Options menu backdrop
	  - Pulse laser projectile (for Miniboss0)

	* Stop people pausing when the level is complete (which made it
	look like the game hung).

	* Quitting via window manager's cross button no longer crashes.

	* Fix crash when use "-h" or "-w" as last item of command line.

	* Corrected errors when merging windows port.

2004-07-18

	* New graphics:
	  - Mozzie
	
	* Remapping controls menu now works.  All buttons except for
	restart button on joystick/gamepad now fires.

	* Homing things no longer seek invulnerable targets.

	* Coffee coloured chunks for player 2 death.
	
2004-07-17

	* Mozzie movement and firing routines.

	* Pause/resume with joystick.
	
2004-07-16

	* Raid'em now works under Windows.

	* Seborrhea loads directories good (using Allegro file routines).
	(Bubble-) Sorting included.

	* Fixed Seborrhea when running from inside archives.  Directories
	were being considered DT_UNKNOWN and were ignored.

	* Triple buffering.  Hopefully works correctly (can't really tell
	the difference between this and page flipping).

	* Game tweaks: player invincible for longer, stronger robots,
	shields come in quicker.  Player starts only with 7 health in 2
	player mode.

	* Miniboss0 spawn a nuke powerup because it looks good.  Boss0 has
	recoil effect after firing huge laser.

	* Shell graphic tweaked again to be more visible.  More visible
	bug animation.  Enemy plasma have different pic from player's.

2004-07-15

	* Start of customize controls.  Customize controls backdrop.

	* F11 to take screenshots when game is paused.

	* Start of windows port.

	* New toothpaste sound.

2004-07-14

	* Explosion sounds now played by unit rather than BigExplosions.
	Cargo2Player was using die instead of delete causing many
	explosion sounds at startup.

	* Satellites were not dying when flung away and were (sometimes)
	ramming into the boss's children.

	* New toothpaste sound.

	* Miniboss0 engine sound.  Anvil firing sound.

	* Confirmation for quit.

	* Start of scoreboard.
	
2004-07-13

	* Help screen for REdit.  Quit dialog.  Fix autopoll.

	* Miniboss0 moving animation.  Destroyed guns will now leave
	debri.  Whole body debri.

	* Both Boss's health meter drawn at bottom of screen for easy
	access.  Health boosted to be more boss-like.

	* More weapon tweaks.

	* Fix sound panning.  Fix crash when music file is not an MP3.

	* Fix game when compiling without USE_FBLEND.

2004-07-12

	* Campaign mode now plays maps in sequence.

	* Custom map works.  Can not select how many players yet.

	* Units now use more powerful collisionLists.  Bosses can now
	choose to ignore nukes (they probably should).

	* Fixed Miniboss0 causing map to stop even after killed.

	* Fixed typo/bug in Boss0 code.  HugeLaser now kills allies and
	enemies.  Increased fireballs and hunter seeker fire rate to
	compensate.  Better health meter.

	* Menu credits uses timer.

	* Player 2 has own set of graphics/animations.  Better animations.

	* Debri for Anvil, Stone, Viking.

2004-07-11

	* New multi-coloured chunks.

	* BigExplosions now spawn smaller explosions.

	* More impressive player and boss death sequences.

	* Debri level control.

	* GUI and menu stuff.  Better space distribution code (less
	program hangs), cleanup, fixed use of h/v_padding.  Fix slider
	notches and stuff.  Children no longer mark dirty if the parent
	widget already marked it dirty.

2004-07-10

	* New larger and more edible-looking powerup graphics.

	* Tweaked shell graphic to be more visible against rock.

	* Menu stuff.

	* Hopefully the bug bug causing sounds channels to slowly get
	locked is fixed.

	* Reallow player to shoot when dying because otherwise it felt
	weird.

2004-07-09

	* Fix REdit and GUI stuff like sliders and children messaging
	parents.

	* Changed music to use ALMP3_MP3 instead of MP3STREAMs.

	* Music in REdit, select with F2.

	* Music file stored in maps.  Choose in REdit with F3.

	* Volume slider/mute buttons in menu working.  New options menu.
	Quit button works (although dodgy).

2004-07-08

	* Dumbfire missiles.
	
	* Grunt firing routine.

	* REdit and GUI stuff like scrollbars.

2004-07-07

	* Schemer is now a subclass of Deceiver.  Less code copying.

	* New OffcentrePulseWeapon class for units like FireFox.
	
	* Converted many units to use new weapon classes.

	* Fixed dumb bug causing sounds to slowly not play after reset.

	* Completed making level1.map!  (26 different units used).

2004-07-06

	* Lasers now slow down (permanently) when penetrating an enemy.
	This gives them more time to hurt high health things.

	* New simpler statusbars.

	* Simple scoring system.

	* Stubby firing routine.  Moan firing routine.

	* New OffcentreWeapon class for units that rotate and which fire
	weapons from an off centre position.

2004-07-05

	* New graphics:
	  - Centipede
	  - Maser
	  - Railgun
	  - Stubby

	* Restored path drawing of BasicFollower in REdit.

	* Unit collisions with projectiles are now done by the projectile
	rather than the unit.  Makes handling instant projectiles
	(railguns, etc) easier.

	* MiniBoss0's Railgun turret.

	* MiniBoss0 draws health.

2004-07-04

	* New graphics:
	  - Grunt
	  - Moan

2004-07-03

	* New graphics:
	  - Laser projectiles
	  - MiniBoss0

	* MiniBoss0 stuff like turrets, tracks.

	* Made level 2 laser do 2 damage per check (instead of 1)
	otherwise the laser's high damage advantage is usually wasted.

2004-07-02

	* Better detection of when a unit can be deleted.
	
2004-07-01

	* Fixed bug causing crash when player died but still had children.

	* Reserved voices for primary and secondary weapons (2 channels
	each).

	* Statusbar shakes when hurt.
	
2004-06-30

	* New graphics:
	  - Shockwave
	
	* New loadPrerequisites class method which allows units to load
	stuff like projectiles and troublesome units like HunterSeekers.

	* Projectile registry thingo.  Projectiles use loadData (class)
	method to load instead of initialize.  Unnecessary data is freed
	at the same time as units.  Before projectile's data was not being
	freed, even after exitting.  Eek!

	* Boss0's turrets.  Viking fires Shockwaves.  Tweaking
	unit/projectile stats.

	* Map resizing was causing REdit to crash when saving.

	* Map scrolls faster seems more fun.

2004-06-29

	* Firefly uses animation_t.  Fires out of barrels.

	* Seborrhea now handles splines!  Everything converted to use it.
	New improved waypoint code which allocates the right amount
	of memory.

	* Splined updated to handle new spline format.

	* New data loading code was causing HunterSeekers to not be loaded
	(since they weren't added to the map, but were spawned by Boss0).

	* Fixed Makefile.

2004-06-28

	* Cleanup and bug fixes and stuff.

	* Units that are not in the class tables which somehow are on the
	map (other units spawning them, etc) are now removed before
	saving.

	* New OwnsChildren protocol to help REdit.

	* Powerups now follow a spline instead of trying to manually do a
	infinity sign.  Fixed problem with powerups going off the screen.

	* Seborrhea animations now have a getLastFrame method which is
	useful for non-looping animations.

	* BasicFlyer uses animation_t now and (hence) supports looping.
	
	* Unit tweaks and fixes.  EG. Fireflea shoots EvilVulcan
	projectiles now.  Stumpy firing animation, fire out of barrel.
	
2004-06-27

	* Improved receive robot and satellite sequences.  Satellite
	health increased (18->30) since it will hit lots of things.  Robot
	fire rates decreased (since they are overly powerful).
	
	* Cheat (compile-time) option, for extra robots and satellites.

	* New Plasma Rifle behaviour.

	* Boss's huge laser no longer draws over the top of the boss.

	* Boss has a more impressive death sequence.

	* Players near death will spawn sparks.

	* Health meter.

2004-06-26

	* New graphics:
	  - Plasma (plasma-rifle projectile)
	
	* Unit's data now loaded when the map is loaded instead of at
	startup.  Now can play consecutive games via menu.  Also, data is
	only unloaded at the start of a map if it is not required.  This
	removes unnecessary unloading/loading.

	* New Plasma Rifle weapon.

	* Sound/music volume.  (but not the menu sliders).
	
	* Fixed HSlider's behaviour for sliders with precision higher than
	its width.

	* Scrollbars now use slider widgets instead of own implementation.

	* New RaidCheckBox widget.  RaidCheckSlider properly implemented.

	* Added DT_UNKNOWN to Seborrhea containers.

2004-06-25

	* All GUI widgets have h_padding/v_padding variables.

	* Credits scroller working.  Highscore submenu working.

	* Play button works.  At the moment unit's data is being loaded at
	startup (instead of at the start of a map), which is not correct.

	* Menu music.

	* New (horizontal) slider widget for GUI.  RaidCheckSlider
	container widget for volume sliders (checkboxes still to be
	implemented).

2004-06-24

	* Added MP3 music support (AllegroMP3).

	* Boss0's body parts will now spawn powerups on death.
	
	* End level sequence.

	* Corrected bugs caused by newly introduced boss variable (for
	drawing health meters).

	* GUI wrapping boxes now have max-width/height variables.  New
	(bad) space distribution code.  Redit laid out better for larger
	screen sizes.  FIXED-WIDTH/HEIGHT flags are now obsolete.

	* Can now place tiles using RMB in Redit.

	* Beginnings of a main menu.
	
2004-06-23

	* New graphics:
	  - Anvil
	  - Battler
	  - Additional desert tiles (alternate base tile, tents)

	* Stone firing animation.

	* Bosses now get a call right at the end to draw health meters
	(and anything else they want).  Only works for one boss (the most
	recently activated one).  Must conform to new Boss protocol.

	* Renamed Newt/Gecko/Lizard-Tanks to Newt, Gecko, Lizard.
	
2004-06-22

	* New graphics:
	  - Stone
	  - Viking
	  - Walls (desert tile set)

	* BasicTurret class (which is a rip off of BasicTank really).
	
2004-06-21

	* New graphics:
	  - Additional desert tiles

2004-05-20

	* New graphics:
	  - Powerups

	* More status related stuff, including portraits.

	* Seborrhea now ignore hidden files.

	* SebFiles have new getRandomSebum method.

2004-05-19

	* More status related stuff.
	
2004-05-18

	* GeckoTank has tracks.  Fixed other tracks so they don't appear
	invisible on rock.

	* Some status related stuff.

2004-05-16

	* New graphics:
	  - Gecko Tank
	  - Shell

	* Generalized TankTracks so other tanks can use it.

	* LizardTank's tracks work again.  NewtTank also has tracks.
	
2004-05-15

	* New graphics:
	  - Blaze
	  - Fear
	  - Plasma

	* Converted "BITMAP *sprite" in the Thing class to use
	"Sebum<SebImage>".

	* Boss has smoother splines.

2004-05-10

	* New graphics:
	  - HunterSeeker

	* Boss now launches HunterSeekers after a wing is destroyed.
	
2004-05-09

	* SebSample protocol now implements sample playing routines so we
	no longer need to go through "[(SebSampleAllegro*)foo sample]".

	* Boss now has a charging-up animation before firing its huge
	laser.

2004-05-08

	* New graphics:
	  - Laser
	  - Sparks
	
	* New cool looking toothpaste.

	* Player now have brief invulnerable period after getting hurt.

	* Beginnings of a boss.

2004-05-07

	* New graphics:
	  - Explosions
	  - Smoke

	* Completely removed use of store.

	* Player becomes hard to control when dying.

	* Powerups now flicker slightly before changing.  Units also
	flicker better.

2004-05-06

	* Converted more things to use Seborrhea.

	* Better animation support in BasicTank.

	* Maps/tiles are beginning to use Seborrhea instead of store.
	REdit is temporarily broken again.

	* New Seborrhea metafile command:
	  - grid-grab.  Grab from fixed sized grid.  Good for tiles.

2004-05-05

	* Converted more things to use Seborrhea.

2004-05-04

	* Converted lots more things to use Seborrhea.
	  - Many units
	  - Explosions
	  - Homing missile
	  - Missile
	
2004-05-03

	* Start converting Raid to use Seborrhea instead of store.
	  - Chunks
	  - Player
	  - Robot
	  - Satellite
	
2004-05-01

	* New REdit commands:
	  - [1-5] will toggle powerups that a unit will spawn on death.

	* Now any unit can spawn a powerup on death, not just cargos.

2004-04-28

	* New Cargo2Player unit which is the same as a cargo, but only
	spawns when the game is in two-player mode.

2004-04-27

	* New graphics: 
	  - FireFly firing animation
	  - FireFox firing animation

	* Variable map lengths.  Use [R] in redit to change it.
	
2004-04-26

	* New graphics:
	  - EvilVulcan projectile

	* Proper formula for firing from an off-centre position.

2004-04-25

	* New graphics:
	  - Schemer
	  - Stumpy

	* Page flipping.

	* Targetting weapons (should) no longer aim for units off the screen.

	* Some minor bug fixes.
	
2004-04-24

	* New graphics:
	  - Desert tile set
	
	* Modified unit activation code to be more correct.  Units to the
	left/right of the screen no longer activate until they need to.

	* Fixed laser behavior, which was dishing out way too much damage.

	* Fixed bug causing powerups to not spawning after destroying a
	group of cargos, due to the group not being reset after restart.

	* Added RGBA FBlend.

2004-04-23

	* Nukes are no longer projectiles so they will clear away
	projectiles as well as enemy units.  Size of nukes (and
	pregenerated circles) also reduced.

	* Made BasicFollower code less confusing.  Now the
	path_y_displacement variable is calculated at activation (rather
	than set during setX:Y: and being intermingled with activate_y),
	since the origin of the path is always the ship's initial y value.

	* Fixed Kamikaze path for new following code.

	* Deceivers now have variable activation line.

2004-04-21

	* New graphics:
	  - Deceiver

	* Corrected the path drawn by cargos in REdit.

2004-04-20

	* New graphics:
	  - FireFlea
	  - FireFly
	  - FireFox

2004-04-18

	* Use FBlend to draw transparent stuff.

	* Robots now explode on impact when in the kamikaze phase, rather
	than drilling through enemies.

	* New pregenerated circle code to make drawing circles faster.

	* Enemies no longer use player projectiles (which was causing too
	much damage to allies.)

	* Fixed bug in toothpaste code introduced yesterday.

2004-04-17

	* Raid is now two player compatible, but toothpaste doesn't work
	right yet.
	
2004-04-16

	* Players now have a children list which contains robots and
	satellites.

	* REdit now allows multiple tagged units.

	* REdit uses Adime for parts of the gui (group/activation line
	edit box, file selector).

	* Fixed many crashes caused by assuming the player exists.

2004-04-15

	* New graphics:
          - Cargo
	  - Little Death

	* Spline editor functional again.

	* BasicFollow has animation support.  Maybe animation functions
	should be moved into units.

	* Corrected bug in REdit which made snap-to-grid unbelievably
	annoying to use.  Proper rounding code finally written.

	* Implemented player death and (temporary) restart level.

	* Some game tweaking to make it more survivable.
	
2004-04-14

	* New REdit commands:
	  - [D] sets the movement distance for units which conform to the
	  "FiniteTravelRange" protocol (tanks).	
	  - [G] sets the group number for units which conform to the
	  "Groupable" protocol (cargo ships).  Very shoddy code.

	* Grouping code written.  Cargo ships now only spawn powerups if
	the entire group has been destroyed.
        
	* Satellites now fly away after death instead of exploding.

	* BasicFlyer has animation support.
	
	* Corrected sound panning calculation and de-xaggerated the
	panning effect (so when x = leftmost, pan is not leftmost).

	* Fixed memory leaks in linked list code and waypoint code causing
	the program to sometimes hang on exit.  (Note: spline-editor is
	currently broken as a result.)

	* Projectiles can choose to not be rotated to prevent ugliness.

	* Various REdit tweaks to make it more usable, like improved
	scrollbars.

2004-04-13

	* New graphics:
	  - Battle-cruiser
	
	* New REdit command:
	  - Plus/Minus (keypad) changes activate_y.

	* Units can now vary activate_y, but they need to do their own
	loading/saving routines.  (Tanks will do this).

	* Units can now creep up from behind the player.

        * BasicFollowers no longer save redundant angle variable.

	* BasicTank now has a finite movement distance (which is not yet
	settable in REdit).

	* Quasi-functional scrollbars in REdit.

	* Cleaned up some active/enable inconsistancies which caused much
	confusion to myself.  Now active means "in the active list"
	(ie. will be drawn, etc.), while enable means "I will move, etc".

2004-04-12

	* New graphics:
	  - Satellite

	* New REdit command:
	  - [Delete] removes the tagged unit.

	* Non-auto-fire implemented for improved gameplay.

	* Made outer satellites rotate clockwise to look less stupid.

	* Units now have load/save routines of their own so that they can
	store additional information (EG. group number for cargo).

	* The tagged unit (in REdit) can draw additonal stats if needed.

	* Fixed REdit bug so right-click no longer removes units while in
	tile editing mode.

2004-04-11

	* New graphics:
	  - Conquerer
	  - Fireball
	  - Homing Missile
	
	* New REdit command:
	  - [Escape] untags a unit.

	* Added tertiary weapons, and moved robots (from secondary
	weapons) and satellites to it.  Satellites now come in pairs and
	max out at 4 (instead of 3) for game balance.

2004-04-09 ~ 2004-04-10

	* New graphics:
	  - Bug
	  - Cruiser
	  - Kamikaze
	  - Lizard Tank
	  - Missile
	  - Newt Tank
	  - Player

	* Made BasicTank class more friendly to use.

	* Made powerup into things rather than projectiles so that
	robots and satellites don't pick them up.

	* Removed old 'Spike' projectile.

2004-04-05 ~ 2004-04-08

	* New projectile:
	  - Toothpaste

	* New REdit command:
	  - [RMB-held] rotates the tagged unit.

	* Added powerups.
	
	* Maps now save angle information.

	* Lotsa undocumented stuff.
